﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 주문
    /// </summary>
    public class Order
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 주문 ID - OrderID

        /// <summary>
        /// 주문 ID
        /// </summary>
        public int OrderID { get; set; }

        #endregion
        #region 고객 ID - CustomerID

        /// <summary>
        /// 고객 ID
        /// </summary>
        public string CustomerID { get; set; }

        #endregion
        #region 주문일 - OrderDate

        /// <summary>
        /// 주문일
        /// </summary>
        public DateTime? OrderDate { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 주문 리스트 구하기 - GetOrderList(connection)

        /// <summary>
        /// 주문 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <returns>주문 리스트</returns>
        public static List<Order> GetOrderList(IDbConnection connection)
        {
            var resultList = connection.Query<Order>("SELECT * FROM Orders ORDER BY OrderID ASC").ToList();

            return resultList;
        }

        #endregion
        #region 주문 리스트 구하기 - GetOrderList(connection, customer)

        /// <summary>
        /// 주문 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <param name="customer">고객</param>
        /// <returns>주문 리스트</returns>
        public static List<Order> GetOrderList(IDbConnection connection, Customer customer)
        {
            var resultList = connection.Query<Order>
            (
                "SELECT * FROM Orders WHERE CustomerID = @CustomerID ORDER BY OrderID ASC",
                customer
            ).ToList();

            return resultList;
        }

        #endregion
    }
}